<?php
/*
Simple:Press Forum V3.1
Hook Template
*/

/* 

	The functions in this template file are empty but are available to the user to add functionality or extra display elements.
	DO NOT OVERWRITE THIS FILE IN THE FUTURE IF YOU USE IT

	To use these hook functions do NOT 'echo' content as this will print it above the forum body. 
	Content should be 'returned' for display.

*/

if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { 
	die('Access Denied'); 
}

/*  
======================================================
All Views
======================================================  */


	/* ---------------------------------------------------
	sf_hook_pre_content()
	Will display content prior to everything else  
	including any textual content that was passed with the 
	WordPress Page itself. 
	This will display on all forum views
	------------------------------------------------------ */

	function sf_hook_pre_content()
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_post_content()
	Displays content after any text belonging to the 
	WordPress page but prior to the start of forum display.
	This will display on all forum views
	------------------------------------------------------ */

	function sf_hook_post_content()
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_footer_inside()
	Displays content above the Simple Forum copyright 
	message at the bottom of the forum display. This is
	still within the main div of the forum itself. 
	This will display on all forum views
	------------------------------------------------------ */

	function sf_hook_footer_inside()
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_footer_outside()
	Displays after the copyright message and outside of the
	forum div itself. Literally the bottom of the page 
	prior to your themes footer
	This will display on all forum views
	------------------------------------------------------ */
	
	function sf_hook_footer_outside()
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_post_loginstrip()
	Inserts content after the login strip and before the 
	breadcrumbs. 
	This will display on all forum views
	------------------------------------------------------ */

	function sf_hook_post_loginstrip()
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_post_breadcrumbs()
	Inserts content immediately after the breadcrumbs.
	This will display on all forum views
	------------------------------------------------------ */

	function sf_hook_post_breadcrumbs()
	{
		return '';
	}


/*  
======================================================
Front/Main Page - Group/Forum Listing
======================================================  */


	/* ---------------------------------------------------
	sf_hook_group_header()
	Displays content on the front (Group) page only - 
	after page content but before any forum display. 
	Content appears above the admin bar and login strip. 
	Introduced in version 3.0
	------------------------------------------------------ */

	function sf_hook_group_header()
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_post_group($groupid)
	Displays content after each Group on the main/front 
	Forum listing page. The GROUP_ID is passed if needed. 
	------------------------------------------------------ */

	function sf_hook_post_group($groupid)
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_post_forum($forumid)
	Will insert content immediately after each forum row
	following the forum description. The FORUM ID is 
	passed into the hook if needed.
	------------------------------------------------------ */
	
	function sf_hook_post_forum($forumid)
	{
		return '';
	}


/*  
======================================================
Forum/Topic Listing
======================================================  */


	/* ---------------------------------------------------
	sf_hook_forum_header()
	Displays content on the forum (list topics) page only - 
	after page content but before any forum display. 
	Content appears above the admin bar and login strip. 
	Introduced in version 3.0
	------------------------------------------------------ */

	function sf_hook_forum_header()
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_post_topic($forumid, $topicid)
	Inserts content immediately after each topic row. The 
	FORUM ID and the TOPIC ID are passed into the 
	hook if needed
	------------------------------------------------------ */

	function sf_hook_post_topic($forumid, $topicid)
	{
		return '';
	}


/*
======================================================
Topic/Post Listing
======================================================  */


	/* ---------------------------------------------------
	sf_hook_topic_header()
	Displays content on the topic (list posts) page only - 
	after page content but before any forum display. 
	Content appears above the admin bar and login strip. 
	Introduced in version 3.0
	------------------------------------------------------ */

	function sf_hook_topic_header()
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_post_post($topicid, $postid)
	Inserts content at the bottom of each post  
	immediately after the users signature (if used). The 
	TOPIC ID and the POST ID are passed into the hook.
	------------------------------------------------------ */

	function sf_hook_post_post($topicid, $postid)
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_first_post($forumid, $topicid)
	Inserts content at the bottom of a topics first post  
	immediately after the users signature (if used). The 
	FORUM ID and the TOPIC ID are passed into the hook.	
	Introduced in version 3.1.2
	------------------------------------------------------ */

	function sf_hook_first_post($forumid, $topcid)
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_last_post($forumid, $topicid)
	Inserts content at the bottom of a topics last post  
	immediately after the users signature (if used). The 
	FORUM ID and the TOPIC ID are passed into the hook.	
	Introduced in version 3.1.2
	------------------------------------------------------ */

	function sf_hook_last_post($forumid, $topcid)
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_other_posts($forumid, $topicid)
	Inserts content at the bottom of all posts in a topic
	except the first and last posts immediately after the
	users signature (if used). The FORUM ID and the 
	TOPIC ID are passed into the hook.	
	Introduced in version 3.1.2
	------------------------------------------------------ */

	function sf_hook_other_posts($forumid, $topcid)
	{
		return '';
	}
	

/*
======================================================
Special Requirements
======================================================  */


	/* ---------------------------------------------------
	sf_hook_post_feedflare($permalink)
	Content will be displayed below the sf_post_post_hook
	above. The individual post's permalink is passed 
	Introduced in Version 3.0
	------------------------------------------------------ */

	function sf_hook_post_feedflare($permalink)
	{
		return '';
	}

	/* ---------------------------------------------------
	sf_hook_post_save($permalink, $content)
	This hook is fired upon the saving of a new post. Both
	the post's permalink and it's content are passed.
	NOTE: This hook accepts no return content
	Introduced in Version 3.0
	------------------------------------------------------ */

	function sf_hook_post_save($permalink, $content)
	{
		return;
	}
    
    # ------------------------------------------------------------------
    # sf_feedback_form()
    #
    # Feedback form for a particular user on a particular topic
    # 	$topicid:         The relevant BST topic to which the feedback pertains
    #	$recipientid:     The user receiving the feedback
    #
    # ------------------------------------------------------------------

    function sf_feedback_form($topicid, $recipientid) {
    	global $current_user, $wpdb, $sfvars, $bst_forum;

    	$out .= '<div id="sforum">'."\n";
        $out .= '<br />';
        
        # Logged in check
        if ($current_user->guest) {
            $out .= '<p>' . sprintf(__("You must be <a href='%s?action=login'>logged in</a> to leave feedback.", "sforum"), SFURL) . '</p>';
            $out .= '</div>' . "\n";
            return $out;
        }
        
        # Does recipient exist?
        $recipient = get_userdata($recipientid);
        if (!$recipient) {
            $out .= '<p>' . __('Sorry, that user does not exist.', "sforum") . '</p>';
            $out .= '</div>' . "\n";
            return $out;
        }
        
        # Make sure they're not submitting feedback about themselves
        if ($recipientid == $current_user->ID) {
            $out .= '<p>' . __('You cannot give feedback about yourself.', "sforum") . '</p>';
            $out .= '</div>' . "\n";
            return $out;
        }
        
        # User in topic check
        $recipient_posted = sf_find_user_in_topic($topicid, $recipientid);
        if (empty($recipient_posted)) {
            $out .= '<p>' . __('The feedback recipient did not post in that topic.', "sforum") . '</p>';
            $out .= '</div>' . "\n";
            return $out;
        }
        
        # Get forum from topic
        $forumid = sf_get_forum_from_topic($topicid);
        if (!in_array($forumid, $bst_forum)) {
            $out .= '<p>' . __('That topic is not in a buy and sell forum, so you cannot leave feedback for it.', "sforum") . '</p>';
            $out .= '</div>' . "\n";
            return $out;        
        }
        
        # Make sure there isn't already a duplicate piece of feedback
        $feedback_exists = $wpdb->get_var('SELECT COUNT(*) FROM ' . SFFEEDBACK . ' WHERE receiver = ' . $recipientid . ' AND giver = ' . $current_user->ID . ' AND topic = ' . $topicid);
        if ($feedback_exists) {
            $out .= '<p>' . __('You have already given feedback for that user, relating to that post.', "sforum") . '</p>';
            $out .= '</div>' . "\n";
            return $out;           
        }
        
        # Feedback submitted
        if ($_POST['submitfeedback']) {
            check_admin_referer('forum-userform_feedback');
            
            # Make sure they have submitted a valid rating
            $rating = substr($_POST['rating'], 0, 3);
            if (!in_array($rating, array('pos', 'neu', 'neg'))) {
                $out .= '<p>' . __('Invalid or missing rating.', "sforum") . '</p>';
                $out .= '</div>' . "\n";
                return $out;
            }
            
            # Make sure they have submitted a comment
            $comment = strip_tags(substr($_POST['comment'], 0, 100));
            if (empty($comment)) {
                $out .= '<p>' . __('Missing comment.', "sforum") . '</p>';
                $out .= '</div>' . "\n";
                return $out;            
            }
            
            # Make sure they have submitted a valid buy/sell value
            $buysell = $_POST['buysell'];
            if (!in_array($buysell, array('buy', 'sell'))) {
                $out .= '<p>' . __('Invalid or missing buy/sell designation.', "sforum") . '</p>';
                $out .= '</div>' . "\n";
                return $out;
            }
            
            # Insert the new feedback!
            $feedback_insert = $wpdb->insert(
                SFFEEDBACK,
                array('receiver' => $recipientid, 'giver' => $current_user->ID, 'topic' => $topicid, 'buysell' => $buysell, 'pos_neu_neg' => $rating, 'comment' => $comment, 'timestamp' => time())
            );
            
            if ($feedback_insert) {
                $out .= '<p>' . "\n";
                $out .= '<img class="sficon" src="' . SFRESOURCES . 'success.png" alt="Success" /> ';
                $out .= __('Feedback submitted!', "sforum");
                $out .= "\n";
                $out .= '</p><br />' . "\n";
                $out .= '<p><a href="' . SFURL . '?feedbackprofile&user=' . $recipientid . '">';
                $out .= __("View this user's updated feedback profile.", "sforum");
                $out .= '</a></p>' . "\n";

            }
            else {
                $out .= '<p>' . __('Database error when adding new feedback. Please contact the administrator.', "sforum") . '</p>' . "\n";
            }
            $out .= '</div>' . "\n";
            return $out;
        }
        
    	$out.='<br />'."\n";
    	$out.='<div id="sfstandardform">'."\n";
    	$out.='<fieldset>'."\n";
    	$out.='<legend>'.sprintf(__("Leave feedback for: %s", "sforum"), '<strong>' . $recipient->user_login.'</strong> ('.stripslashes($recipient->display_name).')').'</legend>'."\n";

    	$out.='<form action="'.SFURL.'?feedback&topic=' . $topicid . '&recipient=' . $recipientid . '" method="post" name="addfeedback">'."\n";

    	if(function_exists('wp_nonce_field')) 
    	{
    		$out.= '<input type="hidden" name="_wpnonce" value="' . wp_create_nonce('forum-userform_feedback') . '" />'."\n";
    		$ref = sf_attribute_escape($_SERVER['REQUEST_URI']);
    		$out.= '<input type="hidden" name="_wp_http_referer" value="'. $ref . '" />'."\n";
    		
    		if ( wp_get_original_referer() ) {
    			$original_ref = sf_attribute_escape(stripslashes(wp_get_original_referer()));
    			$out.= '<input type="hidden" name="_wp_original_http_referer" value="'. $original_ref . '" />'."\n";
    		}
    	}

        $topic_name = sf_get_topic_name(sf_get_topic_slug($topicid));

        $out .= '<p>' . sprintf(__("In the topic %s, %s was a:", "sforum"), '<a href="' . SFURL . sf_get_forum_slug($forumid) . '/' . sf_get_topic_slug($topicid) . '">' . $topic_name . '</a>', '<strong>' . $recipient->user_login . ' (' . stripslashes($recipient->display_name) . ')</strong>') . '</p>' . "\n";
        $out .= '<p><input type="radio" name="buysell" value="buy" /> ' . __('Buyer', "sforum") . ' ' . "\n";
        $out .= '<input type="radio" name="buysell" value="sell" /> ' . __('Seller', "sforum") . '</p>' . "\n";
        $out .= '<p>' . __('Feedback:', "sforum") . '</p>' . "\n";
    	$out .= '<p><input type="radio" checked="checked" name="rating" value="pos" /> ';
        $out .= __('Positive ', "sforum") . "\n";
    	$out .= '<input type="radio" name="rating" value="neu" /> ';
        $out .= __('Neutral ', "sforum") . "\n";
    	$out .= '<input type="radio" name="rating" value="neg" /> ';
        $out .= __('Negative', "sforum") . "\n";
        $out .= '<p><input type="text" name="comment" size="80" maxlength="100" /></p>' . "\n";

    	$out.='<br /><input type="submit" class="sfcontrol" name="submitfeedback" value="'.__("Leave Feedback", "sforum").'" />'."\n";
    	$out.='&nbsp;<input type="button" class="sfcontrol" name="button3" value="'.__("Return to Forum", "sforum").'" onclick="sfjreDirect(\''.SFURL.'\');" />'."\n";

    	$out.='</form>'."\n";
    	$out.='</fieldset>'."\n";
    	$out.='<br />'."\n";
    	$out.='</div></div>'."\n";

    	return $out;
    
    }

    # ------------------------------------------------------------------
    # sf_feedback_profile()
    #
    # Feedback profile showing feedback received from BST transactions
    # 	$userid:         The user ID of the registered user
    #
    # ------------------------------------------------------------------

    function sf_feedback_profile($userid) {
    	global $wpdb;
        
    	$out .= '<div id="sforum">'."\n";
        $out .= '<br />';
        
        # Does user exist?
        $user = get_userdata($userid);
        if (!$user) {
            $out .= '<p>' . __('Sorry, that user does not exist.', "sforum") . '</p>';
            $out .= '</div>' . "\n";
            return $out;
        }
        
        # Grab user's feedback items
        $feedback_items = $wpdb->get_results('SELECT giver, topic, buysell, pos_neu_neg, comment, timestamp, display_name 
            FROM ' . SFFEEDBACK . ' 
            LEFT JOIN ' . SFMEMBERS . ' 
            ON ' . SFFEEDBACK . '.giver = ' . SFMEMBERS . '.user_id
            WHERE receiver = ' . $userid);
        $feedback_count = count($feedback_items);
    	
    	$out.='<h2>' . sprintf(__("Feedback profile for: %s", "sforum"), $user->display_name)."</h2><br />\n";
    	
    	$out.='<p>'.__("Name", "sforum").': <strong>'.$user->first_name.' '.$user->last_name.'</strong></p>'."\n";


    	$out.='<p>'.__("Location", "sforum").': <strong>'.$user->location.'</strong></p>'."\n";
    	$out.='<p>'.__("Website URL", "sforum").': <strong>'.$user->user_url.'</strong></p>'."\n";
    	$out.='<p>'.__("Total # of feedback", "sforum").': <strong>'.$feedback_count.'</strong></p><br />'."\n";
        
        if ($feedback_count) {
            $out .= '<table class="feedback">' . "\n";
            $out .= '<tr bgcolor="#EEEEEE">' . "\n";
            $out .= '<th width="20%">Date</th>' . "\n";
            $out .= '<th width="40%">Comment</th>' . "\n";
            $out .= '<th width="15%">From</th>' . "\n";
            $out .= '<th width="15%">Topic</th>' . "\n";
            $out .= '<th width="10%"></th>';
            $out .= '</tr>' . "\n";
            $i = 1;
            foreach ($feedback_items as $feedback_item) {
                if ($i % 2) {
                    $bgcolor = '#FFFFFF';
                }
                else {
                    $bgcolor = '#DDFFDD';
                }
                $out .= '<tr bgcolor="' . $bgcolor . '">' . "\n";
                $out .= '<td>' . date('M j, Y', $feedback_item->timestamp) . '</td>' . "\n";
                $out .= '<td>' . $feedback_item->comment . '</td>' . "\n";
                $out .= '<td><a href="' . SFURL . '?feedbackprofile&user=' . $feedback_item->giver . '">' . $feedback_item->display_name . '</a></td>' . "\n";
                $out .= '<td><a href="' . SFURL . sf_get_forum_slug(sf_get_forum_from_topic($feedback_item->topic)) . '/' . sf_get_topic_slug($feedback_item->topic) . '">' . __('View topic', "sforum") . '</a></td>' . "\n";
                $out .= '<td><img src="' . SFRESOURCES . $feedback_item->pos_neu_neg . '.gif" alt="' . $feedback_item->pos_neu_neg . '" /></td>' . "\n";

                $out .= '</tr>' . "\n";
                ++$i;
            }
            $out .= '</table>' . "\n";
        }
        $out .= '<p><img src="' . SFRESOURCES . 'pos.gif" alt="Positive" /> = ' . __('positive', "sforum") . '</p>' . "\n";
        $out .= '<p><img src="' . SFRESOURCES . 'neu.gif" alt="Neutral" /> = ' . __('neutral', "sforum") . '</p>' . "\n";
        $out .= '<p><img src="' . SFRESOURCES . 'neg.gif" alt="Negative" /> = ' . __('negative', "sforum") . '</p>' . "\n";
        
        $out .= '</div>' . "\n";
    	return $out;
    
    }
?>